angular.module('aom.services')
  .factory('aomEventSrv', function () {
    const eventSrv = {};
    let events = {};

    eventSrv.register = function (name, cb) {
      events[name] = {
        name: name,
        cb: cb
      };
    };

    eventSrv.trigger = function (name, param) {
      if (events[name]) events[name].cb(param);
    };

    eventSrv.unregister = function (name) {
      if (events[name]) delete events[name];
    };

    return eventSrv;
  });