'use strict';
angular.module('aom.directives')
  .directive('aomOfflineDatabase', function ($ionicActionSheet, $timeout, aomOfflineDatabasesSrv, aomResourcesSrv, aomStyleSrv, constants, aomScreenSizeSrv) {
    return {
      scope: {

      },
      controller: function ($scope) {
        $scope.data = {
          offlineDatabasesSrvData: aomOfflineDatabasesSrv.data,
          resources: aomResourcesSrv.data.resources,

          isRefreshing: false
        };

        $timeout(function () {
          aomOfflineDatabasesSrv.getStoredOfflineDatabaseRecords();
        });

        $scope.data.rowClass = aomStyleSrv.getRowClass();
        $scope.isTablet = aomScreenSizeSrv.isTablet;

        $scope.status = function (database) {
          return database.status ? $scope.data.resources.OfflineDatabases.Success : $scope.data.resources.OfflineDatabases.Failed;
        };

        function showOptions() {
          var options = [];
          // options.push({ text: 'Delete all Databases', key: 'Delete' }); //TODO Enable for Developer mode
          options.push({ text: '<div class="' + (!$scope.data.offlineDatabasesSrvData.importing ? 'refresh' : 'norefresh') + '">' + aomResourcesSrv.data.resources.OfflineDatabases.Refresh + '</div>', key: 'Refresh' });

          $ionicActionSheet.show({
            buttons: options,
            titleText: aomResourcesSrv.data.resources.AomActionSheetOptions.Title,
            cancelText: aomResourcesSrv.data.resources.Common.Cancel,
            cancel: function () {
              return true;
            },
            buttonClicked: function (index, object) {
              if (object.key === 'Refresh') $scope.handleRefresh();
              else if (object.key === 'Delete') aomOfflineDatabasesSrv.deleteOfflineDatabases();
              return true;
            },
            cssClass: 'database-options'
          });
        }

        $scope.$on(constants.broadcastEvents.showOfflineDatabaseOptions, function () {
          showOptions();
        });

        $scope.handleRefresh = function () {
          $scope.data.isRefreshing = true;

          $timeout(function () {
            aomOfflineDatabasesSrv.fetchOfflineDatabases();
            $scope.data.isRefreshing = false;
          }, 1000);
        };

      },
      templateUrl: 'App/Components/OfflineDatabases/offlineDatabases.html'
    };
  });
